;BomberMan 0.10 on 1998-99 By Eric Piel  < Eric.Piel@etu.utc.fr >
;Alan Kwan http://myweb.eni.net/alankwan/   < modemguy@geocities.com >
;need some undocumented Z80 instructions


;INFO
;20 frames/sec
;210 sec
;15*9 board


#include CRASH82.INC
SZTitle:
.db "BomberMan",6,"MultiPlayer",0	;6 is a big space

;;;;;;;;;  CONSTANTs  ;;;;;;;;;;;
fRAMEpERsEC	= 20			; just for the timer
gAMEdURATION	= 200			; in sec
sCREENhEIGHT	= 9*6
sCREENwIDTH	= 15*6
sCREENoRIX	= 3
sCREENoRIY	= 1
bOMBfLASH	= 28
SizeBBM		= 10
NbOfGameToWin	= 3			;; should be customisable

;;;;;;;;;  LOCATIONs  ;;;;;;;;;;;
PlayerWorking	= OP1		;byte	;66 bytes for all OPX
Linked		= OP1 + 1	;byte	; I'm not sure it'll be used
PlayersState	= OP1 + 2	;byte	;Each set bit signifies BBM# is dead
GameTimer	= OP1 + 3	;word
StringTemp	= OP6 + 10	;6 bytes (less most of the time) finishing at this address
BBM1		= OP1 + 5
BBM2		= BBM1 + SizeBBM
BBM3		= BBM1 + (2*SizeBBM)
BBM4		= BBM1 + (3*SizeBBM)
;Relative position of the BBM information
BBMPos		= 0			;Position
BBMY		= 0
BBMX		= 1
BBMDir		= 2			;direction
BBMOldDir	= 3			;direction of BBM drawn
BBMRem		= 4			;Nb Of Bombs Remaining
BBMExp		= 5			;Expantion
BBMBn		= 6			;Bonnus
BBMType		= 7			;0=Not Here   1=On calc1 2=On calc2  3=AI1 4=AI2  5=Link
BBMSprPtr	= 8			;Pointer to its sprite (2 bytes)

;;;;;;;;;;;  BBM Types  ;;;;;;;;;
TypeNH		= 0
TypeOC1		= 1
TypeOC2		= 2
TypeAI1		= 3
TypeAI2		= 4
TypeLK		= 5


;;;;;;;  Bomb Allocation Table  ;;;;;;;;
BATStart	= TEXT_MEM
SizeBAT		= 128
;relative position of the bomb information
BbTimer		= 0
BbPos		= 1
BbY		= 1
BbX		= 2
BbBBMNb		= 3
SizeBb		= 4

LvlBuf		= APD_BUF	;just for 135	;TEXT_MEM2

Start:
	res	1,(iy + 0dh)		;do not affect text memory
	res	7,(iy + 14h)		;write directly to LCD

	ld	hl,BitmapTitle
	ld	de,GRAPH_MEM
	ld	bc,12*25
	ldir
	ld	h,d
	ld	l,e
	inc	de
	ld	(hl),0
	ld	bc,2ffh - (12*25)
	ldir
	call	CR_GRBCopy

CheckAPD_BUF:			; By Hideaki Omuro & Jeff Mears
	LD  A, (INT_STATE)	; Find the Interrupt State
	OR  A \ JR  Z, OkAPD    ; If clear, then go ahead and use the APD_BUF
	LD	HL, (APD_FREE)	; Find the amount of free APD_BUF
	LD	DE, 9*15	; Compare to amount of memory needed
	CALL	CP_HL_DE
	JR	NC, OkAPD	; Go ahead and use the APD_BUF if enough.
	ld	hl,$1A10
	ld	(GRAF_CURS), hl
	ld	hl,UnloadStr
	ROM_CALL(D_ZM_STR)
	jp	CR_KHAND        ; Wait for a key and Quit
OkAPD:

	;The menu
	LD	HL, 241ah
	LD	(GRAF_CURS), HL
	LD	HL,SZMenuCG
	ROM_CALL(D_ZM_STR)
	LD	bc, 2c1ah
	LD	(GRAF_CURS), bc
	ROM_CALL(D_ZM_STR)
	LD	bc, 341ah
	LD	(GRAF_CURS), bc
	ROM_CALL(D_ZM_STR)
	LD	bc, 2c17h
	LD	(GRAF_CURS), bc
	ld	a,0c1h			;'['
	ROM_CALL(M_CHARPUT)
	LD	HL,SZMenuNG
	ROM_CALL(D_ZM_STR)
	ld	a,']'
	ROM_CALL(M_CHARPUT)
	call	CR_KHAND
	cp	K_QUIT
	ret	z
	cp	K_MODE
	ret	z


;;; configuration menu


	ld	hl,0006h		;to be a Zstring and to draw a big blank
	ld	(StringTemp-1),hl
	ld	hl,0
	ld	(GameWon),hl
	ld	(GameWon +2),hl
;;;;

BattleStart:
	set	7,(iy + 14h)		;write to graph

	ld	hl,GameState		;Set all variables of games
	ld	de,Linked
	ld	bc,GameStateEnd-GameState
	ldir

	ld	hl,State1		;Set all variables of level
	ld	de,GameTimer
	ld	bc,StateEnd-State1
	ldir

	ld	hl,GRAPH_MEM
	ld	de,GRAPH_MEM + 1
	ld	(hl),0
	ld	bc,2ffh
	ldir

	ld	hl,BATStart
	ld	de,BATStart + 1
	ld	(hl),0
	ld	bc,SizeBAT - 1
	ldir

	ld	hl,GRAPH_MEM + (12 * 56)		; a nice black line
	ld	de,GRAPH_MEM + (12 * 56) + 1
	ld	(hl),0ffh
	ld	bc,11
	ldir

	ld	bc,9*15
	ld	de,LvlBuf
	ld	hl,Lvl1
	ldir

	ld	bc,0
	ld	hl,LvlBuf
DrwLvl:
	ld	a,(hl)
	push	hl
	bit	7,a
	jr	nz,DrwMask
	and	01110000b
	cp	DesBlock
	jr	z,DrwDBlock
	cp	UndBlock
	jr	z,DrwUBlock
	ld	a,(hl)
	and	00001111b
	jr	z,NextPieceLvl
DrwBn:
	ld	hl,SprBonus - 6
	ld	d,0
	ld	e,a
	rla				;carry reset
	add	a,e
	rla
	ld	e,a			;e= a*6
	add	hl,de
	jr	DrwPieceLvl
DrwUBlock:
	ld	hl,SprUBlock
	jr	DrwPieceLvl
DrwDBlock:
	ld	hl,SprDBlock
	jr	DrwPieceLvl
DrwMask:
	ld	hl,SprMask
DrwPieceLvl:
	push	bc
	call	QuickDraw
	pop	bc
NextPieceLvl:
	pop	hl
	ld	a,b
	add	a,6
	cp	sCREENwIDTH
	jr	nz,NoAddB
	ld	a,c
	add	a,6
	cp	sCREENhEIGHT
	jr	z,FinDrwLvl
	ld	c,a
	xor	a			;;to change the coordinates of the screen
NoAddB:
	ld	b,a
	inc	hl
	jr	DrwLvl
FinDrwLvl:
FDLBBM1:
	ld	a,(PlayersState)
	rra
	jr	c,FDLBBM2
	ld	ix,BBM1
	push	af
	call	DrwBBM
	ld	bc,053ah - ((sCREENoRIX * 100h) + sCREENoRIY)		;Bar on the botton
	ld	hl,SprBBM1Down
	call	QuickDraw
	ld	hl,390ch
	ld	(GRAF_CURS),hl
	ld	a,(GameWon + 0)
	add	a,'0'
	ROM_CALL(M_CHARPUT)
	pop	af
FDLBBM2:
	rra
	jr	c,FDLBBM3
	ld	ix,BBM2
	push	af
	call	DrwBBM
	ld	bc,503ah - ((sCREENoRIX * 100h) + sCREENoRIY)			;Bar on the botton
	ld	hl,SprBBM2Down
	call	QuickDraw
	ld	hl,3957h
	ld	(GRAF_CURS),hl
	ld	a,(GameWon + 1)
	add	a,'0'
	ROM_CALL(M_CHARPUT)
	pop	af
FDLBBM3:
	rra
	jr	c,FDLBBM4
	ld	ix,BBM3
	push	af
	call	DrwBBM
	ld	bc,193ah - ((sCREENoRIX * 100h) + sCREENoRIY)		;Bar on the botton
	ld	hl,SprBBM3Down
	call	QuickDraw
	ld	hl,3920h
	ld	(GRAF_CURS),hl
	ld	a,(GameWon + 2)
	add	a,'0'
	ROM_CALL(M_CHARPUT)
	pop	af
FDLBBM4:
	rra
	jr	c,FDLNoBBM4
	ld	ix,BBM4
	push	af
	call	DrwBBM
	ld	bc,3d3ah - ((sCREENoRIX * 100h) + sCREENoRIY)		;Bar on the botton
	ld	hl,SprBBM4Down
	call	QuickDraw
	ld	hl,3944h
	ld	(GRAF_CURS),hl
	ld	a,(GameWon + 3)
	add	a,'0'
	ROM_CALL(M_CHARPUT)
	pop	af
FDLNoBBM4:

DebBoucleJeu:
BJBBM1:
	ld	a,(PlayersState)
	rra		
	jr	c,BJNoBBM1
	ld	ix,BBM1
	ld	hl,PlayerWorking
	ld	(hl),%00000001
	call	TestKey
	call	DeplacBBM
	jr	BJBBM2
BJNoBBM1:
	halt
	halt
BJBBM2:
	ld	a,(PlayersState)
	bit	1,a
	jr	nz,BJNoBBM2
	ld	ix,BBM2
	ld	hl,PlayerWorking
	ld	(hl),%00000010
	call	TestKey
	call	DeplacBBM
	jr	BJBBM3
BJNoBBM2:
	halt
	halt
BJBBM3:
	ld	a,(PlayersState)
	bit	2,a
	jr	nz,BJNoBBM3
	ld	ix,BBM3
	ld	hl,PlayerWorking
	ld	(hl),%00000100
	call	TestKey
	call	DeplacBBM
	jr	BJBBM4
BJNoBBM3:
	halt
	halt
BJBBM4:
	ld	a,(PlayersState)
	bit	3,a
	jr	nz,BJNoBBM4
	ld	ix,BBM4
	ld	hl,PlayerWorking
	ld	(hl),%00001000
	call	TestKey
	call	DeplacBBM
	jr	BJCont
BJNoBBM4:
	halt
	halt

BJCont:
	call	CheckBomb		;;inline
	call	CR_GRBCopy
	call	CountBBMDead
	cp	3
	jr	c,TestExitKey
	jr	z,PrepareEnd
	jp	EndDraw

TestExitKey:
	ld	a,%10111111
	out	($01),a			; Mask out Mode
	in	a,($01)
	bit	6,a
	jr	nz,AddTime
	call	GET_KEY			;to avoid the key push is counted in CrASH
	ret
PrepareEnd:
	ld	hl,(GameTimer)
	ld	de,40h
	call	CP_HL_DE
	jr	c,AddTime
	ld	(GameTimer),de

AddTime:
;;Flash the screen when small?
	ld	hl,(GameTimer)
	dec	hl
	ld	(GameTimer),hl
	ld	a,l
	or	h			;h=0 and l=0 <=> (l or h)=0
	jr	z,EndGame
ContTime:
	ld	a,fRAMEpERsEC
	call	DIV_HL_A
	dec	a
	jp	nz,DebBoucleJeu		; only once every sec
	call	CountBBMDead
	cp	3
	jr	nc,DontWriteTime
;DISP_HL	;the famous routine but I don't know who wrote it!?
	ld de,StringTemp - 1
DHLRepeat:
	call UNPACK_HL
	add a,'0'
	dec de
	ld (de),a
	ld a,h
	or l
	jr nz,DHLRepeat
	ld	hl,392Ah
	ld	(GRAF_CURS),hl
	ex de,hl
	ROM_CALL(D_ZM_STR)
DontWriteTime:
	jp	DebBoucleJeu
EndGame:
	call	CountBBMDead
	cp	3
	jr	c,EndTime
	jr	z,EndWin
	jp	EndDraw
EndTime:
	ld	hl,$0303
	ld	(CURSOR_POS),hl
	ld	hl,SZEndTime
        ROM_CALL(D_ZT_STR)
	ld	hl,$0304
	jr	WriteDraw	;even it's not draw game
	jr	KeyEndBattle

EndWin:
	ld	hl,$0603
	ld	(CURSOR_POS),hl
	ld	hl,SZEndWin
        ROM_CALL(D_ZT_STR)
	ld	hl,$0404
	ld	(CURSOR_POS),hl
	ld	hl,SZPlayer
        ROM_CALL(D_ZT_STR)
	ld	de,(PlayersState)	;just e
	ld	hl,GameWon - 1
	xor	a
EWCountLoop:
	inc	a
	rr	e
	inc	hl
	jr	c,EWCountLoop
	add	a,'0'
	push	hl
	ROM_CALL(TR_CHARPUT)
	pop	hl		;;needed?
	inc	(hl)
	ld	a,(hl)
	add	a,'0'
	ld	de,4
	add	hl,de
	ld	l,(hl)
	ld	h,39h
	ld	(GRAF_CURS),hl
	res	7,(iy + 14h)		;write directly to LCD
	push	af
	ROM_CALL(M_CHARPUT)
	pop	af			;needed
	cp	NbOfGameToWin + '0'
	jr	c,KeyEndBattle
	ld	hl,$0403
	ld	(CURSOR_POS),hl
	ld	hl,SZGameWon
        ROM_CALL(D_ZT_STR)
KeyEndGame:
	call	CR_KHAND
	cp	K_MODE
	ret	z
	cp	K_ENTER
	jr	nz,KeyEndGame
	jp	Start

EndDraw:
	ld	hl,$0303
WriteDraw:
	ld	(CURSOR_POS),hl
	ld	hl,SZEndDraw
        ROM_CALL(D_ZT_STR)

KeyEndBattle:
	call	CR_KHAND
	cp	K_MODE
	ret	z
	cp	K_ENTER
	jr	nz,KeyEndBattle
	jp	BattleStart


;ix=BBM
CreateBomb:
	ld	a,(ix + BBMDir)		;mustn't move
	or	a
	ret	nz
	ld	a,(ix + BBMRem)
	or	a
	ret	z
	ld	c,(ix + BBMY)
	ld	b,(ix + BBMX)
	ld	h,b
	ld	l,c
	call	GetAddressInLvl
	ld	a,(hl)
	and	01100000b
	cp	Bomb
	ret	z
	dec	(ix + BBMRem)
	push	hl
	push	bc
	ld	hl,BATStart + BbTimer - SizeBb
	ld	bc,SizeBb
	xor	a
	ld	e,0ffh
CNBLoopFindBlank:
	inc	e
	add	hl,bc			;;perhaps chk if it's over the BAT
	cp	(hl)
	jr	nz,CNBLoopFindBlank
	ld	(hl),50h		;BbTimerMax
	pop	bc
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	a,(PlayerWorking)
	inc	hl
	ld	(hl),a
	pop	hl
	ld	a,(hl)
	and	HIDDEN
	or	e			;nb of the bomb
	or	Bomb
	ld	(hl),a
	ld	hl,SprBomb
	push	ix
	call	PutSprClpXOR
	pop	ix
	ret

;hl= Bomb in BAT
ExpendBomb:

	inc	hl			;Update ix
	inc	hl
	inc	hl
	ld	a,(hl)
	ld	ix,BBM1			;;proportional
	rra
	jr	c,EBBBMFound
	ld	ix,BBM2
	rra
	jr	c,EBBBMFound
	ld	ix,BBM3
	rra
	jr	c,EBBBMFound
	ld	ix,BBM4
EBBBMFound:
	inc	(ix + BBMRem)

	dec	hl			;to destroy the bomb itself
	dec	hl
	call	LD_HL_MHL
	push	hl		
	call	GetAddressInLvl
	ld	a,(hl)
	and	00011111b
	ld	e,a			;save the nb of the bomb
	ld	a,HIDDEN
	and	(hl)
	ld	(hl),a
	pop	hl
	ld	b,(ix + BBMExp)
	ld	c,b
	push	bc
	push	de
	push	hl
	call	SetFireInSquare
	pop	hl
	pop	de
	pop	bc
					;;Should be a routine ?
	push	de
	push	hl
ExpdBbUp:
	ld	a,l
	or	a
	jr	z,ExpdBbDownIni	;Out of the screen
	sub	6
	ld	l,a
	push	bc
	push	de
	push	hl
	call	SetFireInSquare
	pop	hl
	pop	de
	pop	bc
	or	a
	jr	z,ExpdBbDownIni
	djnz	ExpdBbUp

ExpdBbDownIni:
	pop	hl
	pop	de
	ld	b,c
	push	de
	push	hl
ExpdBbDown:
	ld	a,l
	cp	8*6
	jr	z,ExpdBbLeftIni	;Out of the screen
	add	a,6
	ld	l,a
	push	bc
	push	de
	push	hl
	call	SetFireInSquare
	pop	hl
	pop	de
	pop	bc
	or	a
	jr	z,ExpdBbLeftIni
	djnz	ExpdBbDown

ExpdBbLeftIni:
	pop	hl
	pop	de
	ld	b,c
	push	de
	push	hl
ExpdBbLeft:
	ld	a,h
	or	a
	jr	z,ExpdBbRightIni	;Out of the screen
	sub	6
	ld	h,a
	push	bc
	push	de
	push	hl
	call	SetFireInSquare
	pop	hl
	pop	de
	pop	bc
	or	a
	jr	z,ExpdBbRightIni
	djnz	ExpdBbLeft

ExpdBbRightIni:
	pop	hl
	pop	de
	ld	b,c
ExpdBbRight:
	ld	a,h
	cp	6*14
	jr	z,ExpdBbEnd		;Out of the screen
	add	a,6
	ld	h,a
	push	bc
	push	de
	push	hl
	call	SetFireInSquare
	pop	hl
	pop	de
	pop	bc
	or	a
	jr	z,ExpdBbEnd
	djnz	ExpdBbRight
	
ExpdBbEnd:
	ret


;IN: hl=XY in Graph	e=Nb of the bomb
;RETURN: a is null if the line of bombing must stop(collision) ;;why not a flag
SetFireInSquare:
	push	de
	ld	de,(PlayersState)	;only for e
	sla	e
	ld	bc,(BBM1+BBMPos)
	call	CpFireWithBBM
	call	z,BBM1Dead
	ld	bc,(BBM2+BBMPos)
	call	CpFireWithBBM
	call	z,BBM2Dead
	ld	bc,(BBM3+BBMPos)
	call	CpFireWithBBM
	call	z,BBM3Dead
	ld	bc,(BBM4+BBMPos)
	call	CpFireWithBBM
	call	z,BBM4Dead

SFISTstCase:
	push	hl
	call	GetAddressInLvl
	ld	a,(hl)
	and	01110000b
	pop	bc			;ld	hl,bc
	pop	de			;from the begining of the routine
	cp	DesBlock
	jr	z,EraseBlock
	cp	UndBlock
	jp	z,LineFinished		;;
	and	01100000b
	cp	Fire
	jr	z,AlreadyFire
	cp	Bomb
	jr	z,ExpendOtherBomb
SetFire:
;;;
	ld	a,(hl)
	and	00001111b
	jr	z,SFBnNull
	push	de
	push	hl
	ld	hl,SprBonus - 6
	ld	e,a
	rla				;carry	reset by and
	add	a,e
	rla
	ld	e,a
	ld	d,0
	add	hl,de
	push	bc
	call	PutSprClpXOR
	pop	bc
	pop	hl
	pop	de
;;;
SFBnNull:
	ld	a,(hl)
	and	HIDDEN
	or	e
	or	Fire
	ld	(hl),a
	ld	hl,SprFire
	call	PutSprClpXOR
	ld	a,1			;;needed?
	ret

AlreadyFire:
	ld	a,(hl)
	and	11100000b
	or	e
	ld	(hl),a
;	ld	a,1			;;a is <> 0 already, isn't it?
	ret

EraseBlock:
	ld	a,(hl)
	and	10001111b
EBStoreBn:
	ld	(hl),a
	ld	d,a
	and	00001111b
	jr	z,EBSetFire
	cp	BnRand
	jr	nz,EBBn
	call	RAND
	and	00001111b		;;depends of the nb of Bn
	cp	00001101b
	jr	c,EBRandCorrect		;BnQuicker mustn't be too much
	xor	a
EBRandCorrect:
	sra	a		;;depends of the nb of Bn
	sra	a
	ld	d,a
	ld	a,(hl)
	and	HIDDEN
	or	d
	jr	EBStoreBn
EBBn:
	bit	7,d
	jr	nz,LineFinished
	ld	hl,SprBonus - 6
	ld	e,a
	sla	a
	add	a,e			;carry reset
	rla
	ld	e,a
	ld	d,0
	add	hl,de
	jr	EBDrawSpr
EBSetFire:
	ld	a,d
	or	Fire
	or	e
	ld	(hl),a
	rla
	jr	c,LineFinished
	ld	hl,SprFire
EBDrawSpr:
	push	bc
	call	QuickDraw
	pop	bc
	ld	hl,SprDBlock
	call	QuickDraw	
LineFinished:
	xor	a
	ret

ExpendOtherBomb:
	ld	a,(hl)
	and	00011111b
	rla				;carry is reset
	rla
	ld	e,a
	ld	d,0
	ld	hl,BATStart + BbTimer
	add	hl,de
	ld	a,(hl)			;save the previous Timer to know if the bomb is drawn or not
	cp	12
	jr	c,EOBDontChangeTimer
	ld	(hl),11
EOBDontChangeTimer:
	cp	bOMBfLASH
	jr	nc,EOBRemoveSprBomb
	bit	2,a			;set=> blank (if a<bOMBfLASH)
	jr	z,DontNeedToRmvBmb

EOBRemoveSprBomb:
	inc	hl
	ld	c,(hl)			;BbY
	inc	hl
	ld	b,(hl)			;BbX
	ld	hl,SprBomb
	call	PutSprClpXOR
DontNeedToRmvBmb:
	xor	a			;ld	a,1			;;needed?
	ret

BBM1Dead:
	ld	a,%00000001
	jr	BBMDeadEnd
BBM2Dead:
	ld	a,%00000010
	jr	BBMDeadEnd
BBM3Dead:
	ld	a,%00000100
	jr	BBMDeadEnd
BBM4Dead:
	ld	a,%00001000
BBMDeadEnd:
	push	hl
	ld	hl,PlayersState
	push	af
	or	(hl)
	ld	(hl),a
	pop	af
	ld	ix,BBM1 - SizeBBM
	ld	de,SizeBBM
BBMDFindIt:
	add	ix,de
	rra
	jr	nc,BBMDFindIt
	push	af
	call	DrwBBM
	pop	af
	pop	hl
	ret	


;c=Nb of the bomb
EndOfFire:
	ld	hl,LvlBuf
	ld	b,9*15
	ld	a,c
	or	Fire
	ld	c,a
EOFRepeatBlock:
	ld	a,(hl)
	and	01111111b
	cp	c
	jr	nz,EOFNextBlock
EOFDelBlock:
	push	hl
	ld	a,(hl)
	and	10000000b
	ld	(hl),a
	jr	nz,EOFHidden
	push	bc
	call	ConvLBToXY
	ld	b,h
	ld	c,l
	ld	hl,SprFire		;;
	call	QuickDraw
	pop	bc
EOFHidden:	
	pop	hl
EOFNextBlock:
	inc	hl
	djnz	EOFRepeatBlock
	ret
                   

CheckBomb:
	ld	hl,BATStart + BbTimer - SizeBb
	ld	de,SizeBb
	ld	b,(SizeBAT / SizeBb)+ 1
	ld	c,0ffh
CBNextBomb:
	xor	a
CBLoopNull:
	dec	b
	ret	z
	add	hl,de
	inc	c
	cp	(hl)
	jr	z,CBLoopNull

	dec	(hl)			;BbTimer
	ld	a,(hl)
	cp	bOMBfLASH
	jr	nc,CBNextBomb
	cp	8		;;
	jr	nz,CBDontExp
	push	bc
	push	de
	push	hl
	ld	a,40h + 6		;scroll the screen to simulate explosion
	out	(P_LCD_CON),a
	call	ExpendBomb
	pop	hl
	pop	de
	pop	bc
	jr	CBNextBomb
CBDontExp:
	cp	6
	jr	nz,CBDontScrollScreen
	ld	a,40h - 3 + 64
	out	(P_LCD_CON),a
CBDontScrollScreen:
	cp	4
	jr	nz,CBDontResetScreen
	ld	a,40h			;reset the screen as it was before the explosion
	out	(P_LCD_CON),a
CBDontResetScreen:
	or	a
	jr	nz,BombTFlash
	push	bc
	push	de
	push	hl
	call	EndOfFire
	pop	hl
	pop	de
	pop	bc
	jr	CBNextBomb
BombTFlash:
	cp	8
	jr	c,CBNextBomb
	inc	a			;;
	and	%00000011		;modulo 4
	jr	nz,CBNextBomb
BombTInvert:
	push	bc
	push	de
	push	hl
	inc	hl
	ld	c,(hl)			;BbY
	inc	hl
	ld	b,(hl)			;BbX
	ld	hl,SprBomb
	call	PutSprClpXOR
	pop	hl
	pop	de
	pop	bc
	jr	CBNextBomb

;ix=BBM
TestKey:
	ld	a,(ix + BBMType)
	cp	TypeOC1		;; could use dec a
	jr	z,TKOC1
	cp	TypeOC2
	jr	z,TKOC2
	cp	TypeAI1
	jr	z,TKAI1
	cp	TypeAI2
	jr	z,TKAI2
TKLink:
	ld	a,0ffh		;;should be a link routine
	halt
	jr	TKKeyReceived

TKAI1:
	ld	a,0ffh		;;should be a AI routine
	halt
	jr	TKKeyReceived

TKAI2:
	ld	a,0ffh		;;should be a better AI routine
	halt
	jr	TKKeyReceived

TKOC1:
	;arrows + clear
        ld	a,0ffh			; reset keyport	;Thank you Harper Maddox (from Chicken)
        out	(1),a			; necessary code
	ld	a,%11111110
	out	($01),a			; Mask out Arrows
	in	a,($01)
	ld	b,a
	ld	a,%11111101
	out	($01),a			; Mask out Clear
	in	a,($01)
	or	10111111b
	and	b
	jr	TKKeyReceived

TKOC2:
	;Sto>:right 4:Left 0:down 2:up  +  '.'
        ld	a,0ffh			; reset keyport	;Thank you Harper Maddox (from Chicken)
        out	(1),a			; necessary code
	ld	a,%11110111
	out	($01),a			; Mask out '.'/2
	in	a,($01)
	bit	0,a
	jr	nz,NotP2Bomb
	set	0,a
	res	6,a
NotP2Bomb:
	bit	1,a
	jr	nz,P22ndTest
	set	1,a
	res	2,a
P22ndTest:	
	ld	b,a
        ld	a,0ffh			; reset keyport	;Thank you Harper Maddox (from Chicken)
        out	(1),a			; necessary code
	ld	a,%11001111
	out	(1),a			; Mask out 0/sto>/4
	in	a,(1)
	bit	2,a
	jr	nz,P2End
	set	2,a
	res	3,a
P2End:
	and	b

TKKeyReceived:
;in a:
;bit 0 res = down
;bit 1 res = left
;bit 2 res = right
;bit 3 res = up
;bit 4 not used
;bit 5 not used
;bit 6 res = Bomb
;bit 7 not used

	push	af
	bit	6,a
	call	z,CreateBomb		;;inline
	pop	af
	or	(ix + BBMDir)		;Compatible with the current dpl ?

	rrca
	jr	nc,DownBBM
	rrca
	jr	nc,LeftBBM
	rrca
	jr	nc,RightBBM
	rrca
	ret	c

UpBBM:
	ld	a,(ix + BBMY)
	or	a
	ret	z
	ld	b,%00001110		;Mask for Down
	ld	de,-6
	jr	FinTestKey

DownBBM:
	ld	a,(ix + BBMY)
	cp	sCREENhEIGHT - 6	;;;6x6
	ret	z
	ld	b,%00000111		;Mask for Up
	ld	de,6
	jr	FinTestKey

LeftBBM:
	ld	a,(ix + BBMX)
	or	a
	ret	z
	ld	b,%10001011		;Mask for Right
	ld	de,-600h
	jr	FinTestKey

RightBBM:
	ld	a,(ix + BBMX)
	cp	sCREENwIDTH - 6
	ret	z
	ld	b,%10001101		;Mask for Left
	ld	de,600h

FinTestKey:
	call	IsCasePossible
	ld	(ix + BBMDir),b
	ret


;ix=BBM		b=FutureDpl	de=mvt
;returns b as new Dpl
IsCasePossible:
	ld	a,(ix + BBMDir)		;Dpl?
	or	a
	ret	nz			;It has been possible so it's possible
	ld	l,(ix + BBMY)
	ld	h,(ix + BBMX)
NextIP:
	add	hl,de
	call	GetAddressInLvl
	ld	a,(hl)
	and	01110000b
	jr	z,ICPBonus
	cp	DesBlock
	jr	z,NotPossible
	cp	UndBlock
	jr	z,NotPossible
	and	01100000b
	cp	Bomb
	jr	z,NotPossible
	cp	Fire
	ret	nz
KillBBMIP:
	ld	a,(PlayerWorking)
	ld	hl,PlayersState
	or	(hl)
	ld	(hl),a
	push	ix
	call	DrwBBM
	pop	ix
NotPossible:
	ld	b,0
	ret
ICPBonus:
	ld	a,(hl)
	ld	(hl),0
	bit	7,a
	jr	z,ICPTstBn
	ld	(hl),HIDDEN
ICPTstBn:
	and	00001111b
	ret	z
	cp	BnMoreBb		;;dec	a
	jr	z,ICPMoreBb
	cp	BnMoreExp		;;dec	a
	jr	z,ICPMoreExp
;	cp	BnQuicker		;;dec	a
;	jr	z,ICPQuicker
ICPQuicker:
	push	bc
	push	ix
	set	0,(ix + BBMBn)
	call	ConvLBToXY
	ld	b,h
	ld	c,l
	ld	hl,SprBnQuicker
	jr	ICPEraseBn
ICPMoreExp:
	push	bc
	push	ix
	inc	(ix + BBMExp)
	call	ConvLBToXY
	ld	b,h
	ld	c,l
	ld	hl,SprBnMoreExp
	jr	ICPEraseBn
ICPMoreBb:
	push	bc
	push	ix
	inc	(ix + BBMRem)
	call	ConvLBToXY
	ld	b,h
	ld	c,l
	ld	hl,SprBnMoreBb
ICPEraseBn:
	call	PutSprClpXOR
	pop	ix
	pop	bc
	ret


;ix = BBM
DeplacBBM:
	ld	a,(ix + BBMDir)		;dpl?
	or	a
	jr	nz,IsMoving
	halt				;It must be slow down to compensate
	ret
IsMoving:
	push	af
	push	hl
	push	ix
	call	DrwBBM
	pop	ix
	pop	hl
	pop	af

	ld	(ix + BBMOldDir),a
	rrca
	jr	nc,UpDplBBM
	rrca
	jr	nc,RightDplBBM
	rrca
	jr	nc,LeftDplBBM
DownDplBBM:
	bit	0,(ix + BBMBn)		;;should be a parallel case (all 2 | all 1)
	jr	z,DDSmall
	inc	(ix + BBMY)	
DDSmall:
	inc	(ix + BBMY)	
	ld	a,(ix + BBMY)
	ld	c,a
	ld	b,(ix + BBMX)
	jr	FinDplBBM

UpDplBBM:
	bit	0,(ix + BBMBn)
	jr	z,UDSmall
	dec	(ix + BBMY)
UDSmall:
	dec	(ix + BBMY)
	ld	a,(ix + BBMY)
	ld	c,a
	ld	b,(ix + BBMX)
	jr	FinDplBBM
	
RightDplBBM:
	bit	0,(ix + BBMBn)
	jr	z,RDSmall
	inc	(ix + BBMX)
RDSmall:
	inc	(ix + BBMX)
	ld	a,(ix + BBMX)
	ld	b,a
	ld	c,(ix + BBMY)
	jr	FinDplBBM
	
LeftDplBBM:
	bit	0,(ix + BBMBn)
	jr	z,LDSmall
	dec	(ix + BBMX)
LDSmall:
	dec	(ix + BBMX)
	ld	a,(ix + BBMX)
	ld	b,a
	ld	c,(ix + BBMY)

FinDplBBM:
	push	af
	push	ix
	call	DrwBBMPos
	pop	ix
	pop	af
	ld	l,a
	call	L_by_6			;modulo 6
	or	a
	ret	nz
	ld	(ix + BBMDir),a		;a = 0
	ret



CountBBMDead:
	ld	a,(PlayersState)
	ld	b,a
	xor	a
	rr	b
	adc	a,0
	rr	b
	adc	a,0
	rr	b
	adc	a,0
	rr	b
	adc	a,0			; now a contain the nb of deads
	ret

;return z if BBM is in the same square than bomb 
CpFireWithBBM:
	sra	e
	bit	0,e
	ret	nz
	push	hl
	ld	a,b
	add	a,3			;check the middle of BBM
	ld	l,a
	call	L_by_6
	ld	a,l
	sla	a
	add	a,l
	rla				;at about 3
	ld	b,a
	ld	a,c
	add	a,3
	ld	l,a
	call	L_by_6
	ld	a,l
	sla	a
	add	a,l
	rla
	ld	c,a
	pop	hl
	call	CP_HL_BC
	ret

;hl=XY in Graph		[adefhl]  d=0  , a=e=byte in level , Z=0 C=0
;return hl in LvlBuf
GetAddressInLvl:
	call	L_by_6
	ld	a,l
	sla	a
	rla
	rla
	rla
	sub	l
	ld	e,a			;e=15Y/6=16(Y/6)-(Y/6)
	ld	l,h
	call	L_by_6
	ld	a,l			;a=X/6
	add	a,e
	ld	e,a
	ld	d,0
	ld	hl,LvlBuf
	add	hl,de
	ret

;hl points in LvlBuf	[adefhl]
;return hl = XY in Graph 
ConvLBToXY:
	ld	de,LvlBuf
	or	a			;reset carry flag
	sbc	hl,de
	ld	a,15
	call	DIV_HL_A
	ld	d,a
	sla	a
	add	a,d
	rla
	ld	h,a
	ld	a,l
	rla
	add	a,l
	rla
	ld	l,a
	ret


;return L=int(L/6), A=L MOD 6  [afl] ;algorithm of ti
;flags: Z=1
L_by_6:
        ld      a,6
L_by_A:		;return L=int(L/A), A=L MOD A  [afl]
        push    bc
        ld      c,a
        xor     a
        ld      b,8
Lb6Loop:
	sla	l
        rla     
        cp      c
        jr      c,Lb6NotStill
        sub     c
        inc     l
Lb6NotStill:
	djnz    Lb6Loop
	pop     bc
	ret


QDXSpriteHeight	= 6
;----------------------------------------------------------------------------
;[ QuickDraw ] [ABCDEFIX]                [ modified by Eric to fit the prog ]
; was
;[ PutSprClpXOR ] [ABCDEFIX]                                    [ CrASH_Man ]
;----------------------------------------------------------------------------
; Draws a sprite using only XOR data
;
; parameters: HL -> sprite, (B,C) = coordinates
; returns:    Puts sprite in GRAPH_MEM
;
QuickDraw:
		PUSH HL				; IX -> Sprite
                POP  IX
		ld	a,c
		add	a,sCREENoRIY
		ld	c,a
		ld	a,b
		add	a,sCREENoRIX		;;
		ld	b,a
		LD   B, 0
                LD   H, B
                LD   L, C
                ADD  HL, BC			; HL = Y * 12
                ADD  HL, BC
                ADD  HL, HL
                ADD  HL, HL

                LD   C, A			; HL = Y*12 + X/8
                SRA  C
                SRA  C
                SRA  C
;                INC  C				;done by  LD   BC, GRAPH_MEM + 1

                ADD  HL, BC
                LD   BC, GRAPH_MEM + 1
                ADD  HL, BC

                LD   B, QDXSpriteHeight		; B = number of rows

                CPL
                AND  %00000111			; find number of
                LD   E, A			; instructions to jump
                ADD  A, E
                ADD  A, E
                LD   (_QD_OPchg + 1), A		; 3 * (7 - number)

		LD   DE, 13

_QD_LineLoop:	
		LD   C, (IX)
                XOR  A
_QD_OPchg:	JR   _QD_OPchg			; modify

                RR   C
                RRA
                RR   C
                RRA
                RR   C
                RRA
                RR   C
                RRA
                RR   C
                RRA
                RR   C
                RRA
                RR   C
                RRA

                XOR  (HL)			; XOR with background
		LD   (HL), A			; Write
                DEC  HL				; HL -> next 8 pixels

                LD   A, C
                XOR  (HL)			; XOR with background
		LD   (HL), A			; Write
                ADD  HL, DE			; HL -> next row

                INC  IX				; Increment to next data
                DJNZ _QD_LineLoop
                RET



;;;; IN: IX= pointer to BBM
;   OUT: BBM drawn with dir and clipping
;DESTROY abcdefhlix
DrwBBM:
	ld	b,(ix + BBMX)
	ld	c,(ix + BBMY)
DrwBBMPos:	;IN :BC = coordinates IX= pointer to BBM
	ld	d,(ix + BBMSprPtr +1)
	ld	e,(ix + BBMSprPtr)
DrwBBMPosPtr:	;IN :BC = coordinates  DE= Pointer to sprite IX= pointer to BBM
	ld	l,(ix + BBMOldDir)
DrwBBMPosPtrDir:	;IN :BC = coordinates  DE= Pointer to sprite l= dir
	ld	a,-6
DBContDir:
	add	a,6
	sra	l
	jr	c,DBContDir
	ld	h,0
	ld	l,a
	add	hl,de
;	jp	PutSprClpXOR


ClpXSpriteHeight	= 6
;----------------------------------------------------------------------------
;[ PutSprClpXOR ][ABCDEFIX] [ CrASH_Man ][ modified by Eric to fit the prog ]
;----------------------------------------------------------------------------
; Draws a sprite using only XOR data and clipping
;
;----------------------------------------------------------------------------
;modified by Eric to fit BMMP : no more clipping on the border of the screen 
;but clipping if there is a square masked
;optimisation: clipping both horizontal and vertical cannot exist
;----------------------------------------------------------------------------
;
; parameters: HL -> sprite, (B,C) = coordinates
; returns:    Puts sprite in GRAPH_MEM
;
PutSprClpXOR:		;;6x6
		PUSH HL					; IX -> Sprite
                POP  IX

		push	hl
		ld	l,b
		call	L_by_6
		pop	hl
		or	a
		jr	nz,_SCX_NoVertClp		; not aligned => can't be clipped vertically => go away
		dec	a
		ld	(_SCX_MaskChg +1),a		; a was 0 and we don't want any mask (=1111111b)

		push	hl
		ld	h,b
		ld	a,c
		add	a,ClpXSpriteHeight-1
		ld	l,a
		call	GetAddressInLvl
		ld	a,(hl)
		rla
		pop	hl
		LD	DE,ClpXSpriteHeight		; D = 0, E = Height
                JP	nc, _SCX_NoBotClp		; No bottom clip.
		ld	a,c
		add	a,ClpXSpriteHeight-1
		ld	l,a
		call	L_by_6
		neg
                add	a,ClpXSpriteHeight-1
		ret	z				;should speed up all V-aligned sprites
		LD	E, A
_SCX_NoBotClp:

		push	hl
		ld	h,b
		ld	l,c
		push	de
		call	GetAddressInLvl
		pop	de
		ld	a,(hl)
		rla
		pop	hl
                JP	nc, _SCX_ClpDone
		push	hl
		ld	l,c
		call	L_by_6
		neg
		add	a,ClpXSpriteHeight		;a = size to not draw
		pop	hl
		push	de
		ld	d,0
		ld	e,a
		add	hl,de				;don't want to write the begining of the sprite
		ld	d,a
		add	a,c				; => we have to update the coordinates
		ld	c,a
		ld	a,d
		pop	de
		PUSH HL
                POP  IX					;refreshes the pointer

                SUB	E
		ret	z
                NEG
                LD	E, A
		jr	_SCX_ClpDone
_SCX_NoVertClp: 
;		ld	l,b
;		call	L_by_6				;;we've got it already!!! ;get mod 6
		ld	d,b				; save b
		ld	b,a
		ld	a,00000011b
_SCX_CreateMask:sll	a
		djnz	_SCX_CreateMask			; OK because never V-aligned
		ld	b,a

		push	de
		ld	h,d
		ld	l,c
		call	GetAddressInLvl			;;could use the already done Call L_by_6    ;+3
		pop	de
		ld	a,(hl)
		rla
		ld	e,b				; save the mask
		jr	c,_SCX_LeftClp
		ld	b,0FFh
_SCX_LeftClp:	inc	hl
		ld	a,(hl)
		rla
		ld	a,0FFh
		jr	nc,_SCX_NoRightClp
		ld	a,e
		cpl					; the opposite part of the mask
_SCX_NoRightClp:and	b
		ld	(_SCX_MaskChg +1),a
		ld	b,d				;pop	b
		LD	DE,ClpXSpriteHeight		; D = 0, E = Height


_SCX_ClpDone:   
		ld	a,c
		add	a,sCREENoRIY
		ld	c,a
		ld	a,b
		add	a,sCREENoRIX		;;
		ld	b,a
		LD   B, D			; remember? D = 0
                LD   H, B
                LD   L, C
                ADD  HL, BC			; HL = Y * 12
                ADD  HL, BC
                ADD  HL, HL
                ADD  HL, HL

                LD   C, A			; HL = Y*12 + X/8
                SRA  C
                SRA  C
                SRA  C

                ADD  HL, BC
                LD   BC, GRAPH_MEM + 1		; c=+1
                ADD  HL, BC

                LD   B, E			; B = number of rows

                CPL
                AND  %00000111                    ; find number of
                LD   E, A                         ; instructions to jump
                ADD  A, E
                ADD  A, E
                LD   (_SCX_OPchg_3 + 1), A        ; 3 * (7 - number)

                LD   DE, 13
;;;;
;_SCX_LineLoop:  LD   C, (IX)
;                XOR  A
;to be changed by:
_SCX_LineLoop:	ld	a,(ix)
_SCX_MaskChg:	and	11111111b
		ld	c,a
		xor	a
;or probably better if can change all the other code
;_SCX_LineLoop:	ld	a,(ix)
;_SCX_MaskChg:	and	11111111b
;		ld	c,0
;;;;
_SCX_OPchg_3:   JR   _SCX_OPchg_3			; modify

                RR   C
                RRA
                RR   C
                RRA
                RR   C
                RRA
                RR   C
                RRA
                RR   C
                RRA
                RR   C
                RRA
                RR   C
                RRA

                XOR  (HL)                         ; XOR with background
		LD   (HL), A                      ; Write
                DEC  HL                           ; HL -> next 8 pixels

                LD   A, C
                XOR  (HL)                         ; XOR with background
		LD   (HL), A                      ; Write
                ADD  HL, DE                       ; HL -> next row

                INC  IX                           ; Increment to next data
                DJNZ _SCX_LineLoop
                RET
; DATAs
SZBMMP:		.db "BomberMan",0,"MultiPlayer",0
SZMenuCG:	.db "Continue Game",0
SZMenuNG:	.db "New Game",0
SZMenuOption:	.db "Option",0
SZNGLevel:	.db "Level",0
SZNGPlayer:	.db "Player",0
SZNGLink:	.db "By Link",0
SZPP1:		.db "P1",0
SZPP2:		.db "P2",0
SZPAI1:		.db "AI 1",0
SZPAI2:		.db "AI 2",0
SZPLink:	.db "Linked",0
SZOptionTime:	.db "Time",0

UnloadStr	.db "Disable the interrupt",0

SZEndTime:	.db " time up ",0
SZEndDraw:	.db "DRAW GAME",0CEh,0		;CEh=...
SZEndWin:	.db "WoN",0
SZPlayer:	.db "Player ",0
SZGameWon:	.db "VICTORY!!",0

Level:		.dw	Lvl1
GameWon:	.db	0
		.db	0
		.db	0
		.db	0
TableOfScore:
.db		0ch,57h,20h,44h

GameState:
.db	0			;Linked
.db	00001100b		;PlayersState
GameStateEnd:

BitmapTitle: ;(96*25) = 300 bytes
 .db $ff,$40,$00,$00,$01,$80,$00,$00,$00,$00,$02,$ff
 .db $81,$a3,$e0,$a0,$01,$80,$00,$00,$00,$00,$05,$81
 .db $ff,$4c,$60,$40,$01,$80,$00,$00,$00,$00,$02,$ff
 .db $00,$0c,$c0,$a0,$01,$80,$00,$00,$00,$00,$00,$00
 .db $00,$0f,$f8,$86,$19,$f8,$e3,$6c,$31,$e3,$60,$00
 .db $00,$0e,$19,$c7,$ec,$cd,$b3,$ef,$db,$23,$b0,$00
 .db $1f,$cc,$1a,$67,$6c,$cd,$b3,$0e,$d8,$73,$33,$f8
 .db $3f,$ec,$75,$e7,$6c,$cd,$c3,$0e,$d8,$b3,$37,$fc
 .db $37,$6d,$e5,$e3,$6c,$c9,$b1,$86,$d9,$31,$36,$ec
 .db $32,$6f,$87,$e3,$6c,$d1,$e1,$86,$db,$71,$b6,$4c
 .db $32,$6c,$07,$c3,$6c,$e0,$c1,$86,$db,$b1,$b6,$4c
 .db $32,$60,$03,$80,$00,$00,$00,$00,$00,$00,$06,$4c
 .db $3f,$e0,$00,$00,$0c,$00,$0c,$00,$00,$00,$07,$fc
 .db $1f,$c0,$04,$10,$0d,$98,$0c,$00,$00,$00,$03,$f8
 .db $2a,$a0,$06,$30,$0d,$80,$0c,$00,$00,$00,$05,$54
 .db $57,$50,$06,$33,$6f,$d9,$cc,$e3,$31,$e0,$0a,$ea
 .db $4a,$90,$06,$73,$6c,$d9,$ad,$3f,$69,$e0,$09,$52
 .db $72,$70,$07,$9b,$64,$d9,$b4,$7e,$69,$80,$0e,$4e
 .db $bf,$e8,$06,$9b,$66,$d8,$b6,$f6,$71,$80,$17,$fd
 .db $97,$48,$06,$9b,$66,$d8,$b7,$b6,$68,$c0,$12,$e9
 .db $7f,$f0,$06,$03,$e6,$d8,$a7,$f6,$70,$c0,$0f,$fe
 .db $2d,$a0,$00,$00,$00,$00,$c0,$06,$00,$00,$05,$b4
 .db $3f,$e0,$00,$00,$00,$00,$c0,$06,$00,$00,$07,$fc
 .db $7d,$f0,$00,$00,$00,$00,$c0,$06,$00,$00,$0f,$be
 .db $7d,$f0,$00,$00,$00,$00,$c0,$06,$00,$00,$0f,$be

SprBBM1:			;Order is the same than the direction
SprBBM1Up:
	.db %11111100
	.db %11111100
	.db %01111000
	.db %11001100
	.db %01111000
	.db %11001100
SprBBM1Right:
	.db %11111100
	.db %11110100
	.db %01111000
	.db %01001000
	.db %01111000
	.db %01101100
SprBBM1Left:
	.db %11111100
	.db %10111100
	.db %01111000
	.db %01001000
	.db %01111000
	.db %11011000
SprBBM1Down:
	.db %11111100
	.db %10110100
	.db %01111000
	.db %11001100
	.db %01111000
	.db %11001100

SprBBM2:
SprBBM2Up:
	.db %00110000
	.db %01111000
	.db %11111100
	.db %01111000
	.db %11001100
	.db %11001100
SprBBM2Right:
	.db %00110000
	.db %01001000
	.db %11111100
	.db %00110000
	.db %00111000
	.db %00111000
SprBBM2Left:
	.db %00110000
	.db %01001000
	.db %11111100
	.db %00110000
	.db %01110000
	.db %01110000
SprBBM2Down:
	.db %00110000
	.db %01001000
	.db %11111100
	.db %01111000
	.db %11001100
	.db %11001100

SprBBM3:
SprBBM3Up:
	.db %01111000
	.db %01111000
	.db %11111100
	.db %11111100
	.db %01111000
	.db %11001100
SprBBM3Right:
	.db %01111000
	.db %01001000
	.db %11111100
	.db %11111100
	.db %00110000
	.db %00111000
SprBBM3Left:
	.db %01111000
	.db %01001000
	.db %11111100
	.db %11111100
	.db %00110000
	.db %01110000
SprBBM3Down:
	.db %01111000
	.db %01001000
	.db %11111100
	.db %11001100
	.db %01111000
	.db %11001100

SprBBM4:
SprBBM4Up:
	.db %11111100
	.db %01111000
	.db %10110100
	.db %01111000
	.db %11001100
	.db %10000100
SprBBM4Right:
	.db %11111100
	.db %01001000
	.db %00110000
	.db %01101000
	.db %00110000
	.db %00011000
SprBBM4Left:
	.db %11111100
	.db %01001000
	.db %00110000
	.db %01011000
	.db %00110000
	.db %01100000
SprBBM4Down:
	.db %11111100
	.db %01001000
	.db %10110100
	.db %01111000
	.db %11001100
	.db %10000100


SprDBlock:
	.db %00110000
	.db %01111000
	.db %11101100
	.db %11010100
	.db %11100100
	.db %01111000

SprUBlock:
	.db %01111000
	.db %10000100
	.db %10100100
	.db %10110100
	.db %10000100
	.db %01111000


SprMask:
	.db %10101000
	.db %00000100
	.db %10010000
	.db %00100100
	.db %10000000
	.db %01010100

SprBomb:
	.db %00001100
	.db %01111000
	.db %10011000
	.db %10111000
	.db %11111000
	.db %01110000


SprFire:
	.db %01101000
	.db %10110100
	.db %10011000
	.db %01100100
	.db %10110100
	.db %01101000


SprBlank:			;;;don't know if useful, at least not used yet
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000

SprBonus:		;the order is important, must the be the same than the order of the constants

SprBnMoreBb:
	.db %00011000
	.db %00110000
	.db %01001000
	.db %01011000
	.db %00110000
	.db %00000000


SprBnMoreExp:
	.db %00110000
	.db %01010000
	.db %01001100
	.db %01000100
	.db %10111000
	.db %01000000

SprBnQuicker:
	.db %10010000
	.db %01001000
	.db %10010000
	.db %00000000
	.db %11111000
	.db %00000000

SprBnDead:
	.db %10010000
	.db %01001000
	.db %10010000
	.db %00000000
	.db %11111000
	.db %00000000



State1:		;depends of the level 
.dw	(gAMEdURATION * fRAMEpERsEC) + 2	;GameTimer
	;BBM1
.dw	0000h		;XY
.db	0		;Dir
.db	00000111b	;OldDir		;down
.db	1		;Rem
.db	2		;Exp
.db	0		;Bn
.db	TypeOC1		;Type
.dw	SprBBM1		;Sprite Pointer
	;BBM2
.dw	5430h		;XY
.db	0		;Dir
.db	00000111b	;OldDir
.db	1		;Rem
.db	2		;Exp
.db	0		;Bn
.db	TypeOC2		;Type
.dw	SprBBM2		;Sprite Pointer
	;BBM3
.dw	5400h		;XY
.db	0		;Dir
.db	00000111b	;OldDir
.db	1		;Rem
.db	2		;Exp
.db	0		;Bn
.db	TypeNH		;Type
.dw	SprBBM3		;Sprite Pointer
	;BBM4
.dw	0030h		;XY
.db	0		;Dir
.db	00000111b	;OldDir
.db	1		;Rem
.db	2		;Exp
.db	0		;Bn
.db	TypeNH		;Type
.dw	SprBBM4		;Sprite Pointer
StateEnd:

;Code Block:
Blank		=	00h		;4th Last Signifiant Bits : Bonus
;		=	10h		;not used
Fire		=	20h		;5LSB : n
Bomb		=	40h		;5LSB : n
DesBlock	=	60h		;4LSB : Bonus	
UndBlock	=	70h		;;4LSB : lots of != Graphics?

HIDDEN		=	10000000b	;do a OR with the object to hide it

;Code Bonnus:
BnNull		=	00h	;No bonnus
BnMoreBb	=	01h	;Increase the nb of bomb
BnMoreExp	=	02h	;Increase the expantion of the bombs
BnQuicker	=	03h	;Increase the speed of the BBM
BnRand		=	0fh	;Choosed randomly

Lvl1:
;	    1    2    3    4    5    6    7    8    9    10   11   12   13   14   15 
	.db 00h ,00h ,6fh ,00h ,6fh ,00h ,6fh ,6fh ,00h ,6fh ,6fh ,6fh ,0efh,00h ,00h
	.db 00h ,70h ,6fh ,70h ,00h ,70h ,6fh ,70h ,6fh ,70h ,6fh ,70h ,80h ,70h ,00h
	.db 6fh ,6fh ,00h ,00h ,6fh ,00h ,6fh ,00h ,00h ,6fh ,6fh ,00h ,0efh,00h ,6fh
	.db 6fh ,70h ,00h ,70h ,6fh ,70h ,6fh ,70h ,0efh,70h ,6fh ,70h ,80h ,70h ,6fh
	.db 00h ,00h ,6fh ,6fh ,00h ,6fh ,00h ,80h ,80h ,80h ,6fh ,6fh ,6fh ,00h ,00h
	.db 6fh ,70h ,0efh,0f0h,00h ,70h ,00h ,70h ,0efh,70h ,00h ,70h ,6fh ,70h ,6fh
	.db 6fh ,6fh ,80h ,0efh,6fh ,00h ,6fh ,00h ,6fh ,6fh ,6fh ,00h ,00h ,6fh ,6fh
	.db 00h ,70h ,80h ,0f0h,00h ,70h ,6fh ,70h ,00h ,70h ,00h ,70h ,6fh ,70h ,00h
	.db 00h ,00h ,6fh ,6fh ,6fh ,6fh ,00h ,6fh ,6fh ,00h ,6fh ,00h ,6fh ,00h ,00h

.end
